module icanvas;

import tk.geometry;
import tk.events;
import cairo.Context;

interface Viewport {
    void rel_zoom(Point screen_datum, double factor);
    void rel_pan(Vector screen_displacement);
    //void damage(Rectangle area);

    double zoom() const;
    Point model_to_screen(Point model) const;
    Point screen_to_model(Point screen) const;
    Vector model_to_screen(Vector model) const;
    Vector screen_to_model(Vector screen) const;
    Rectangle model_to_screen(Rectangle model) const;
    Rectangle screen_to_model(Rectangle model) const;
    double model_to_screen(double model) const;
    double screen_to_model(double screen) const;
}

interface EventHandler {
    bool handle_button_press(Viewport viewport, in ButtonEvent event);
    bool handle_button_release(Viewport viewport, in ButtonEvent event);
    bool handle_motion(Viewport viewport, in MotionEvent event);
    bool handle_scroll(Viewport viewport, in ScrollEvent event);
    //bool handle_expose(Viewport viewport, ExposeEvent event);
    //bool handle_enter(Viewport viewport, CrossingEvent event);
    //bool handle_leave(Viewport viewport, CrossingEvent event);
    //bool handle_focus_in(Viewport viewport, FocusEvent event);
    //bool handle_focus_out(Viewport viewport, FocusEvent event);
    bool handle_key_press(Viewport viewport, in KeyEvent event);
    bool handle_key_release(Viewport viewport, in KeyEvent event);
}

abstract class Layer {
    Rectangle bounds() const;
    //void zoom_changed
    void draw(const Viewport viewport, in Rectangle damage, Context cr) const;
}
